/*********************************************************
 * project:     statemachine -- convert statemachine definition in dnf
 * file:        debugfctn.c
 * version:     0.1
 * date:        july, 15. 1995
 * author:      volker bosch (volker.bosch@z.zgs.de)
 *************************************************************************/

#include <stdio.h>
#include <stdlib.h>
      
#include "qmc.h"
#include "listfctn.h"
#include "debugfctn.h"


#ifdef	QMC_DEBUG

/*-----------------------------------------------------------
 *
 *--------------------------------------------------------------------*/
void DebugPrintSignalList(void)
{
  SIGNAL_LIST_ELEMENT *ListElement;

  if((ListElement = StartOfListOfSignals) == NULL) {
    printf("No signal elements\n");
    return;
  }
  while(ListElement != NULL) {
    printf("%d. Signal: \t%s\n", ListElement->Idx, ListElement->Identifier);
    ListElement = ListElement->Successor;
  }
  return;
}

/*-----------------------------------------------------------
 *
 *--------------------------------------------------------------------*/
static void PrintMinTerm(unsigned long DontCare, unsigned long MinTerm) {

  int i;
  unsigned long Mask;
  
  Mask = 1l;
  for(i = 0; i < NumberOfSignals; i++) {
    if((DontCare & Mask) != 0) { 
      printf("x");
    } else {
      if((MinTerm & Mask) == 0)	printf("0");
      else			printf("1");
    } /* if -- else */
    Mask <<= 1;
  } /* for */
}

/*-----------------------------------------------------------
 *
 *--------------------------------------------------------------------*/
static void PrintIdxArray(char *Array) {

int Idx, i;
char Mask;

  if(Array == NULL) {
    printf("<null>");
    return;
  } 
  for(Idx = 0; Idx < SizeOfIdxArray; Idx++) {
    Mask = 1;
    for(i = 0; i < 8; i++) {
      if((Array[Idx] & Mask) != 0) printf("%2d,",((Idx * 8) + i));
      else printf("  ,");
      Mask <<= 1;      
    }
  }
}

/*-----------------------------------------------------------
 *
 *--------------------------------------------------------------------*/
void DebugPrintMinTermList(void) {
  
  int 			Dimension;
  MIN_TERM_LIST_ELEMENT	*MinTermListElement;
  
  for(Dimension = 0; Dimension < NumberOfSignals; Dimension++) {
    MinTermListElement = MinTerms[Dimension].StartOfListOfMinTerms;
    printf("Anz. Don't Cares: %d\n",Dimension);
    if(MinTermListElement == NULL) { 
      printf("<null>\n");
    } else {
      while(MinTermListElement != NULL) {
        PrintMinTerm(MinTermListElement->DontCares, MinTermListElement->MinTerm);
        printf(" Line: %3d", MinTermListElement->InputLineNo);
        printf("Val: %d, Flag: %d, Idx: ",MinTermListElement->Value,  MinTermListElement->Flag);
        PrintIdxArray(MinTermListElement->IdxArray);
        printf("\n");
        MinTermListElement = MinTermListElement->Successor;
      } /* while(MinTermListElement != NULL) */
    } /* if(MinTermListElement == NULL) -- else */
  } /* for */
}

#endif
