/*********************************************************
 * project:     qmc -- minimize dnf using the Quine McCluskey algorithem
 * file:        listfctn.h
 * version:     0.1
 * date:        july, 22. 1995
 * author:      volker bosch (volker.bosch@z.zgs.de)
 *************************************************************************/

/*----------------------------------------------------
 * Returns the Idx of the signal named Identifier
 * If no signal of this name exists, -1 is returned
 *---------------------------------------------------------*/
int GetSignalIdx(char *);

/*----------------------------------------------------
 * Returns the name of the signal with the given index
 * If no signal with this index exists, NULL is returned
 *---------------------------------------------------------*/
char *GetSignalName(int);

/*-----------------------------------------------------
 * Returns the dimension (number of don't cares) of the given 
 * don't care variable
 *-------------------------------------------------------------*/
int GetDontCareDimension(unsigned long);

/*----------------------------------------------------------
 * Checks if the given min term is included or includes previous
 * min terms.
 * Returns line number of the other min term. Zero is returned if no
 * term is found.
 *--------------------------------------------------------------------*/
int CheckMinTerm(MIN_TERM_LIST_ELEMENT *);
     
/*-----------------------------------------------------
 *
 *----------------------------------------------------------*/
int CheckTerms(unsigned long, unsigned long, unsigned long, unsigned long);

/*----------------------------------------------------
 *
 *-----------------------------------------------------------------*/
void StartIdx2IdxArray(void);
